
sounds={}
soundIDs=0



function Distance( x, y, a, b )
return math.sqrt((x-a)^2+(y-b)^2)
end

function newSound( sound )
sounds[tostring(soundIDs)]=love.audio.newSource("sounds/"..sound, "static" )
soundIDs=soundIDs+1
end

function soundUPD()
for k, pot in pairs(sounds) do
love.audio.play(sounds[k])
sounds[k]=nil
end
end

function love.load()
require("shop")
require("buttons")
require("cash")
require("bullet")
require("TheUgly")
zombieTimer=0
I=0
gravity=200
player={}
player.onGround=false
player.x=400
player.y=400
player.yVel=0
player.speed=250
player.hp=100
player.living=true
player.cash=0
player.control=true
player.damage=30
DDealt=0
isBreak=false
wave=1
lastWave=0
kills=0
love.graphics.setBackgroundColor( 0, 200, 255 ) 
love.graphics.setFont(love.graphics.newFont(30))

NewButton( 50, 50, 400, 80, "Buy back Health for $0", HealthUp )
NewButton( 50, 140, 400, 80, "+15 move Speed, $30", SpeedUp )
NewButton( 50, 230, 400, 80, "+5 Damage for $15", DamageUp )

end

function love.update(dt)

if love.timer.getTime()-lastWave>=35 and isBreak==false then
isBreak=true
elseif love.timer.getTime()-lastWave>=50 then
isBreak=false
wave=wave+1
lastWave=love.timer.getTime()
end

if isBreak==false then
if love.timer.getTime()-zombieTimer>=2.5 then
for I=I,math.random(0, wave ) do
if math.random(1,2)==1 then
NewZombi( 0-200*I, 400, 100, 1+math.random() )
else
NewZombi( 800+200*I, 400, 100, 1+math.random() )
end
zombieTimer=love.timer.getTime()
end
end
end

if player.living==true and player.control==true then

if player.hp<=0 then
player.living=false
newSound("death.wav")
end

if love.keyboard.isDown("a") then
if player.x-25-player.speed*dt>=0 then
player.x=player.x-player.speed*dt
end
end

if love.keyboard.isDown("d") then
if player.x+25+player.speed*dt<=800 then
player.x=player.x+player.speed*dt
end
end

if love.keyboard.isDown("w") then
if player.onGround==true then
newSound("jump.wav")
player.yVel=player.yVel-150
player.onGround=false
end
end

if player.y+player.yVel*dt>=400 then
player.yVel=0
player.onGround=true
else
player.onGround=false
end

player.y=player.y+player.yVel*dt
player.yVel=player.yVel+gravity*dt
end

CashUpd()
BulletUpdate(dt)
ZombieUpdate(dt)
soundUPD()
end

function love.keyreleased( key )
if key=="e" and player.living==true then
ToggleShop()
end
end

function love.mousepressed( x, y, button)
if button=="l" and player.living==true and player.control==true then
newSound("shoot.wav")
FireBullet(x)
elseif player.control==false and button=="l" then
UpdateButton()
end
end

function love.draw()
love.graphics.setColor( 255, 255, 255 )
if player.living==true then
love.graphics.rectangle("fill", player.x-25, player.y-100, 50, 100)
end
love.graphics.setColor( 0, 255, 0 )
love.graphics.rectangle("fill", 0, 400, 800, 200 )

love.graphics.setColor( 255, 255, 255 )
love.graphics.rectangle("fill", 595, 0, 205, 105 )

love.graphics.setColor( 80, 80, 80 )
love.graphics.rectangle("fill", 40, 20, 320, 70 )
love.graphics.rectangle("fill", 600, 0, 200, 100 )
if player.living==true then
love.graphics.setColor( 255, 0, 0 )
love.graphics.rectangle("fill", 50, 30, player.hp*3, 50 )
love.graphics.setColor(255, 255, 255)
love.graphics.print(player.hp .."/100", 140, 35, 0)
love.graphics.print("(E. To Toggle Shop", 375, 65, 0, 0.5, 0.75)
end

love.graphics.setColor(255, 255, 255, 255 )
love.graphics.print("Wave: "..wave, 650, 10, 0)
love.graphics.print("Kills: "..kills, 650, 40, 0)
love.graphics.setColor( 255, 255, 0 )
love.graphics.print("Money: $"..player.cash, 625, 70, 0, 0.75, 0.75)
love.graphics.setColor( 255, 0, 0 )
love.graphics.print("Total Damage Dealt: "..DDealt, 450, 550, 0, 0.75, 0.75 )

DrawBullet()
ZombieDraw()
DrawCash()

if player.living==false then
love.graphics.setColor( 255, 0, 0 )
love.graphics.print("You've died, idiot.", 50, 300, 0, 2, 2)
love.graphics.print("0/100", 140, 35, 0)
end

DrawShop()

if love.timer.getTime()-lastWave>=35 and love.timer.getTime()-lastWave<=50 then
love.graphics.setColor( 255, 255, 255, -(17*(love.timer.getTime()-(lastWave+35))))
love.graphics.print("Wave "..wave.." completed, rest your finger.", 50, 400, 0, 1, 1 )
elseif love.timer.getTime()-lastWave<=5 then
love.graphics.setColor( 255, 255, 255, -(51*(love.timer.getTime()-lastWave)))
love.graphics.print("Wave "..wave.." starting!", 50, 400, 0, 1.5, 1.5 )
end


end
